#!/bin/bash
cd `dirname $0`
ARCH=$(adb shell getprop ro.product.cpu.abi | tr -d '\r')
DEVICE=$(adb shell getprop ro.product.device | tr -d '\r')
SERIAL=$(adb shell getprop ro.serialno | tr -d '\r')

SUFFIX=32
if [ "$ARCH" == "arm64-v8a" ]; then
SUFFIX=64
fi

echo "Running on $DEVICE on ${SUFFIX}-bit platform"
echo "Pushing files"
FILES="dirtycow run-as exploitta dumpta checkta"
for FILE in $FILES; do
adb push files/${FILE}${SUFFIX} /data/local/tmp/${FILE}
adb shell "chmod 755 /data/local/tmp/${FILE}"
done
adb push files/backupTA.sh /data/local/tmp/backupTA.sh
adb shell "chmod 755 /data/local/tmp/backupTA.sh"

TAIMG="TA_${DEVICE}_${SERIAL}_$(date -u +%Y%m%d-%H%M).img"
echo "Running scripts to dump ta to \"${TAIMG}\" on device"
adb shell /data/local/tmp/backupTA.sh ${TAIMG}
echo "Pulling image"
adb pull /data/local/tmp/${TAIMG} ${TAIMG}
echo "Cleaning up"
adb shell "rm -f /data/local/tmp/dirtycow /data/local/tmp/run-as /data/local/tmp/exploitta /sdcard/dumpta /data/local/tmp/backupTA.sh"
if [ -f ${TAIMG} ]; then
echo "TA Sucessfully pulled to $TAIMG"
echo "****NOTE: Please verify filesize is 2MB ****"
else
echo "TA Backup Failed!! Please reboot and try again."
echo "NOTE: If you are running Android Nougat, you need to downgrade to use this tool."
fi
